;Jakub Borzdynski 2005
;WERSJA UPROSZCZONA - BEZ KONFIGURATORA
;########################################################
;USTAWIENIA
;-------
;wartosc domyslna temperatury, uklad zaczyna reagowac w momencie, kiedy
;na czujniku pojawi sie ustawiona tu wartosc. Podana jest ona w stopniach
;Celsjusza (w przyblizeniu). Przed wpisaniem nalezy ja podzielic przez 2
;np. jezeli uklad ma reagowac od 50 st. C, nalezy wpisac 25
.equ DEF_temp =10  
;-------
;ilosc krokow silnika wykonywanych dla jednego stopnia Celsjusza. Np. dla
;DEF_kroki =2 przy wzroscie (lub spadku) temperatury o 5 st. C zostanie wykonane
; 2 * 5 = 10 krokow.
.equ DEF_kroki =1 
;-------
;ponizej znajduje sie program - zapraszam tam niepokornych, ktorzy maja
;ochote pomajstrowac :)))
;########################################################
;****************************************************
;Program do obslugi sterownika pieca C.O.
;****************************************************
;OPIS WYPROWADZEN
;L1=PB2, L2=PB1 , L3=PB3 , L4=PB0
;JP1=PB1, JP2=PB2, JP3=PB4
;S_dol=PB3, S_gora=PB0
;
;MAPA EEPROM
; 00H -> bieg
; 01H -> kroki/st. C
; 02H -> temperatura wlaczenia
;************************************************************
;PROGRAM
;definicje
;==============
;******************
.INCLUDE "tn15def.inc"    ; Include I/O definitions 
.def temp  =r16 ;zmienna pomocnicza
.def KROKI =r17 ;kroki/stopien C
.def T_WL  =r18 ;przy jakiej temp. sie uakt.
.def DELTA =r20 ;do obliczania zmiany temp.
.def posrednik =r21 ;posredniczy przy wpisywaniu wartosci
.def wait1 =r22 ;generacja opoznienia
.def wait2 =r23 ;generacja opoznienia
.def wait3 =r24 ;generacja opoznienia
.def SILNIK =r25 ;rejestr przesuwny dla silnika
.def pomiar =r26 ;buforuje pomiar z ADC
;####################################################
;####################################################
RESET: ;tu sie zaczyna program po resecie

	;ustaw maska silnika
	ldi SILNIK, 0x01
	
	;ustawienie JP1, JP2, JP3 jako wejscia z pull-up
	ldi posrednik, 0x00
	out DDRB, posrednik  ;jako wejscie
	ldi posrednik, 0xFF
	out PORTB, posrednik ;z pull-up
	
	;wczytanie ustawien
	ldi T_WL, DEF_temp
	ldi KROKI, DEF_kroki
	
	;ustawienie wyjsc silnikow
		ldi posrednik, 0xFF
		out DDRB, posrednik ;wszystko jako wyjscia
		ldi posrednik, 0x00
		out PORTB, posrednik ;stan niski wszedzie (wylacz prad w uzwoj.)
	
	;konfiguracja przetwornika ADC do pracy
		cbi DDRB, 4 ;jako wejscie
		cbi PORTB, 4 ;wylacz pull-up
		ldi posrednik, 0x03 ;ustaw wartosc
			;w diag jest LEWO!!!!
		out ADMUX, posrednik ;wyr. do lewej, kanal PB4
		ldi posrednik, 0x85 ;ustaw wartosc
		out ADCSR, posrednik ;wlacz, preskaler 16

PETLA_RUN:	
	;wykonanie pomiaru
		sbi ADCSR, ADSC ; rozpoczecie pomiaru
		ADC_czekaj:
		sbic ADCSR, ADSC ;oczekuj na zero
		rjmp ADC_czekaj ;dopoki bedzie 1 - czekaj
		in pomiar, ADCL ;ADCH nie ma znaczenia
		in posrednik, ADCH
		;add pomiar, pomiar ;przetworzenie
	
	;czy pomiar < temp?
		cp pomiar, T_WL ;wykonaj porownanie
		brge licz_DELTA ;nie trzeba wykonywac korekty
		mov pomiar, T_WL ;ustaw dolna wartosc
	
	;wyznaczenie delty
		licz_DELTA:
		mov DELTA, pomiar ;przepisz, aby nie utracic
		sub DELTA, temp ;odejmij od poprzedniego stanu akt. pomiar
		brge DELTA_zero ;okresl, czy wieksza, czy mniejsza
		
		DELTA_mniejsza:
		;err mov DELTA,temp
		neg DELTA ;usun znak
		rcall SILNIK_OBROT_L ;wykanj obrot walu
		rjmp ZWLOKA_WAIT
		
		DELTA_wieksza:
		;err mov DELTA, temp ;przepisz
		rcall SILNIK_OBROT_R ;wykanj obrot walu
		rjmp ZWLOKA_WAIT
			
		DELTA_zero: ;badanie czy DELTA = 0
		ldi posrednik, 0
		cpse DELTA,posrednik
		rjmp DELTA_wieksza
			
	;zwloka czasowa
		ZWLOKA_WAIT:
		ldi wait1, 0xFF ;ustaw
		ldi wait2, 0xFF ;ustaw
		ldi wait3, 0x0F ;ustaw
		ldi posrednik, 0x00 ;do porownan
		ZWLOKA:
		dec wait1
		cpse wait1,posrednik
		rjmp ZWLOKA
		dec wait2
		cpse wait2,posrednik
		rjmp ZWLOKA
		dec wait3
		cpse wait3,posrednik
		rjmp ZWLOKA
		
	mov temp, pomiar ;przepisz i zapamietaj do nast. liczenia
		
	;zapetlenie
rjmp PETLA_RUN
;####################################################
;####################################################
SILNIK_OBROT_L:
	;obroty silnika
	mov wait3, KROKI ;ile obr/st.C
	;petla kroki/st.C * DELTA
	
	OBRACAJ_SILNIK_L:
	;realizacja obrotu o krok
	lsl SILNIK ; przesun "napiecie w uzwojeniu"
	;badanie "przekrecenia" licznika ("SILNIK")
	sbrc SILNIK, 4
	ldi SILNIK, 0x01 ;ustaw cykl od poczatku
	;---------
		;przepisanie na wyjscia
		ldi posrednik,0
		out PORTB, posrednik ;wyzeruj wszystko
		sbrc SILNIK, 0
		sbi PORTB,2
		sbrc SILNIK, 1
		sbi PORTB,1
		sbrc SILNIK, 2
		sbi PORTB,3
		sbrc SILNIK, 3
		sbi PORTB,0
	;--------
	;opoznienie
		ldi wait1, 0xFF ;ustaw
		ldi wait2, 0x18 ;ustaw
		ldi posrednik, 0x00 ;do porownan
		WAIT_SL:
		dec wait1
		cpse wait1,posrednik
		rjmp WAIT_SL
		dec wait2
		cpse wait2,posrednik
		rjmp WAIT_SL
	;================================
	ldi posrednik, 0 ;do porownan
	dec wait3
	cpse wait3,posrednik
	rjmp OBRACAJ_SILNIK_L
	mov wait3, KROKI ;ustaw ilosc obrotow
	dec DELTA
	cpse DELTA,posrednik
	rjmp OBRACAJ_SILNIK_L
	out PORTB, posrednik ;wylacz porty
	;*****************************************
ret ;powrot
;####################################################
;####################################################
SILNIK_OBROT_R:
	;obroty silnika
	mov wait3, KROKI ;ile obr/st.C
	;petla kroki/st.C * DELTA
	
	OBRACAJ_SILNIK_R:
	;realizacja obrotu o krok
	lsr SILNIK ; przesun "napiecie w uzwojeniu"
	;badanie "przekrecenia" licznika ("SILNIK")
	ldi posrednik, 0
	cpse SILNIK, posrednik
	rjmp SILNIK_OK
	ldi SILNIK, 0x08 ;jezeli bylo zero - ustaw wart. pocz
	SILNIK_OK:
	;---------
		;przepisanie na wyjscia
		ldi posrednik,0
		out PORTB, posrednik ;wyzeruj wszystko
		sbrc SILNIK, 0
		sbi PORTB,2
		sbrc SILNIK, 1
		sbi PORTB,1
		sbrc SILNIK, 2
		sbi PORTB,3
		sbrc SILNIK, 3
		sbi PORTB,0
	;--------
	;opoznienie
		ldi wait1, 0xFF ;ustaw
		ldi wait2, 0x18 ;ustaw
		ldi posrednik, 0x00 ;do porownan
		WAIT_SR:
		dec wait1
		cpse wait1,posrednik
		rjmp WAIT_SR
		dec wait2
		cpse wait2,posrednik
		rjmp WAIT_SR
	;================================
	ldi posrednik, 0 ;do porownan
	dec wait3
	cpse wait3,posrednik
	rjmp OBRACAJ_SILNIK_R
	mov wait3, KROKI ;ustaw ilosc obrotow
	dec DELTA
	cpse DELTA,posrednik
	rjmp OBRACAJ_SILNIK_R
	out PORTB, posrednik ;wylacz porty
	;*****************************************
ret ;powrot